diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/savegame.c freeciv-patched/server/savegame.c
--- freeciv-cvs/server/savegame.c	2003-07-07 18:20:27.000000000 +0100
+++ freeciv-patched/server/savegame.c	2003-07-07 18:21:49.000000000 +0100
@@ -24,6 +24,7 @@
 #include "city.h"
 #include "fcintl.h"
 #include "game.h"
+#include "government.h"
 #include "idex.h"
 #include "log.h"
 #include "map.h"
@@ -1813,6 +1814,72 @@
 /***************************************************************
 ...
 ***************************************************************/
+static void govs_load(struct section_file *file)
+{
+  int numcomps, compind, govind;
+
+  numcomps = secfile_lookup_int_default(file, 0, "game.num_compound_govs");
+
+  /* Truncate unit list at the first generated compound gov */
+  for (govind = 0; govind < game.government_count; ++govind) {
+    if (governments[govind].basetype != G_MAGIC) {
+      game.government_count = govind;
+      freelog(LOG_DEBUG, "govs truncated to %d", govind);
+      governments = (struct government *)fc_realloc(governments,
+			game.government_count * sizeof(struct government));
+      break;
+    }
+  }
+  for (compind = 0; compind < numcomps; ++compind) {
+    int modind, modifiers[MAX_MODS];
+    int basetype;
+    char *name;
+
+    name = secfile_lookup_str(file, "game.cgov%d.name", compind);
+    basetype = secfile_lookup_int(file, "game.cgov%d.basetype", compind);
+    for (modind = 0; modind < game.num_gov_modifier_types; ++modind) {
+      modifiers[modind] = secfile_lookup_int(file, "game.cgov%d.modifiers%d",
+	  				     compind, modind);
+    }
+    form_compound_gov(NULL, name, basetype, modifiers);
+  }
+}
+
+/***************************************************************
+...
+***************************************************************/
+static void units_load(struct section_file *file)
+{
+  int numcomps, compind;
+
+  numcomps = secfile_lookup_int_default(file, 0, "game.num_compound_units");
+
+  /* Truncate unit list at the first generated compound unit */
+  unit_type_iterate(uid) {
+    if (unit_types[uid].basetype != U_LAST) {
+      game.num_unit_types = uid;
+      freelog(LOG_DEBUG, "units truncated to %d", uid);
+      break;
+    }
+  } unit_type_iterate_end;
+  for (compind = 0; compind < numcomps; ++compind) {
+    int modind, modifiers[MAX_MODS];
+    Unit_Type_id basetype;
+    char *name;
+
+    name = secfile_lookup_str(file, "game.cunit%d.name", compind);
+    basetype = secfile_lookup_int(file, "game.cunit%d.basetype", compind);
+    for (modind = 0; modind < game.num_unit_modifier_types; ++modind) {
+      modifiers[modind] = secfile_lookup_int(file, "game.cunit%d.modifiers%d",
+	  				     compind, modind);
+    }
+    form_compound_unit(name, basetype, modifiers, NULL);
+  }
+}
+
+/***************************************************************
+...
+***************************************************************/
 void game_load(struct section_file *file)
 {
   int i;
@@ -2041,6 +2108,11 @@
     game.cooling=0;
 
     load_rulesets();
+
+    /* This needs to be after rulesets are loaded so that we can access
+     * the base types for generating compound units */
+    units_load(file);
+    govs_load(file);
   }
 
   {
@@ -2229,6 +2301,70 @@
 /***************************************************************
 ...
 ***************************************************************/
+static void govs_save(struct section_file *file)
+{
+  bool write = FALSE;
+  int govind, compind = -1;
+
+  for (govind = 0; govind < game.government_count; ++govind) {
+    struct government *g = &governments[govind];
+
+    if (!write && g->basetype != G_MAGIC) {
+      write = TRUE;
+      secfile_insert_int(file, game.government_count - govind,
+	  		 "game.num_compound_govs");
+    }
+    if (write) {
+      int modind;
+
+      compind++;
+      secfile_insert_str(file, g->name, "game.cgov%d.name", compind);
+      secfile_insert_int(file, g->basetype, "game.cgov%d.basetype",
+	  		 compind);
+      for (modind = 0; modind < game.num_gov_modifier_types; ++modind) {
+	secfile_insert_int(file, g->modifiers[modind],
+	    		   "game.cgov%d.modifiers%d",
+	    		   compind, modind);
+      }
+    }
+  }
+}
+
+/***************************************************************
+...
+***************************************************************/
+static void units_save(struct section_file *file)
+{
+  bool write = FALSE;
+  int compind = -1;
+
+  unit_type_iterate(uid) {
+    struct unit_type *u = &unit_types[uid];
+
+    if (!write && u->basetype != U_LAST) {
+      write = TRUE;
+      secfile_insert_int(file, game.num_unit_types - uid,
+	  		 "game.num_compound_units");
+    }
+    if (write) {
+      int modind;
+
+      compind++;
+      secfile_insert_str(file, u->name, "game.cunit%d.name", compind);
+      secfile_insert_int(file, u->basetype, "game.cunit%d.basetype",
+	  		 compind);
+      for (modind = 0; modind < game.num_unit_modifier_types; ++modind) {
+	secfile_insert_int(file, u->modifiers[modind],
+	    		   "game.cunit%d.modifiers%d",
+	    		   compind, modind);
+      }
+    }
+  } unit_type_iterate_end;
+}
+
+/***************************************************************
+...
+***************************************************************/
 void game_save(struct section_file *file)
 {
   int i;
@@ -2320,6 +2456,9 @@
   secfile_insert_int(file, game.watchtower_extra_vision, "game.watchtower_extra_vision");
   secfile_insert_int(file, game.allowed_city_names, "game.allowed_city_names");
 
+  units_save(file);
+  govs_save(file);
+
   if (TRUE) {
     /* Now always save these, so the server options reflect the
      * actual values used at the start of the game.
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/srv_main.c freeciv-patched/server/srv_main.c
--- freeciv-cvs/server/srv_main.c	2003-07-07 18:20:27.000000000 +0100
+++ freeciv-patched/server/srv_main.c	2003-07-07 18:21:49.000000000 +0100
@@ -59,6 +59,7 @@
 #include "player.h"
 #include "rand.h"
 #include "registry.h"
+#include "script.h"
 #include "shared.h"
 #include "support.h"
 #include "tech.h"
@@ -176,6 +177,9 @@
   /* initialize teams */
   team_init();
 
+  /* set up script interpreter */
+  script_init();
+
   /* mark as initialized */
   has_been_srv_init = TRUE;
 
@@ -833,6 +837,10 @@
     handle_player_tech_goal(pplayer, (struct packet_player_request *)packet);
     break;
 
+  case PACKET_REQUEST_COMPOUND:
+    handle_request_compound(pplayer, (struct packet_request_compound *)packet);
+    break;
+
   case PACKET_UNIT_BUILD_CITY:
     handle_unit_build_city(pplayer, (struct packet_unit_request *)packet);
     break;
